image: python:3.9

stages:
    - Setup
    - PyTesting
    - BuildDockerImage


.Initial_Setup: &Initial_Setup
    - echo $whoami #Debugging
    - ls -a #Debugging
    - python3 --version #Debugging
    - pip install -r requirements.txt
    - pip install pylint
        

Py_Test:
    stage: PyTesting
    script:
        - *Initial_Setup
        - pylint ./*.py  || true
        
Build_Docker_Image:
    image: docker:latest
    stage: BuildDockerImage
    services:
        - docker:dind
    script:
        - echo "Building Dockerfile, please wait..."
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker build -t $CI_REGISTRY_IMAGE:latest -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA .
        - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
        - docker push $CI_REGISTRY_IMAGE:latest